//+------------------------------------------------------------------+
//|                                            stoch-hellkas-exp.mq4 |
//|                Copyright  2005, Nick Bilak, beluck[AT]gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Nick Bilak"
#property link      "http://www.forex-tsd.com/"
#include <stdlib.mqh>

extern int myMagic=222;

extern double TakeProfit = 70;
extern double StopLoss = 35;
extern double TrailingStop = 0;  
extern double Lots = 0.1;

extern double MaximumRisk = 5; //risk % - stoploss/balance
extern bool   FixedLot = true; //set to false to apply risk MM

extern int K=10;
extern int D=6;
extern int S=6;
extern double LowerLevel = 20; 
extern double UpperLevel = 80;   

extern int    slippage=2;   	//slippage for market order processing
extern int    shift=1;			//shift to current bar, 0 is current, 1 - last closed
extern int    OrderNumberTries=5;

bool buysig,sellsig,closebuy,closesell,bres; 
static int last,tries,res;

double LotsRisk(int StopLoss)  { 
   double lot=Lots;
//---- select lot size
   if (!FixedLot)
      lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk*0.001/StopLoss,1);
   else
      lot=Lots;
//---- return lot size
   if(lot<0.1) lot=0.1;
   return(lot);
}

//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateLong()  {
   int buys;
   string symbol=Symbol();
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==myMagic)
        {
         if(OrderType()==OP_BUY)  buys++;
        }
     }
//---- return orders volume
   return(buys);
}

int CalculateShort()  {
   int sells;
   string symbol=Symbol();
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==myMagic)
        {
         if(OrderType()==OP_SELL) sells++;
        }
     }
//---- return orders volume
   return(sells);
}

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForSignals() {
      
      //indicators values for past 2 bars
   	double stom1=iStochastic(NULL,0,K,D,S,MODE_LWMA,0,MODE_MAIN,shift);
   	double stom2=iStochastic(NULL,0,K,D,S,MODE_LWMA,0,MODE_MAIN,shift+1);
   	double stos1=iStochastic(NULL,0,K,D,S,MODE_LWMA,0,MODE_SIGNAL,shift);
   	double stos2=iStochastic(NULL,0,K,D,S,MODE_LWMA,0,MODE_SIGNAL,shift+1);

      buysig=false;
      sellsig=false;
      
      if (stom1>stos1 && stom2<=stos2 && stom2<LowerLevel) { //long cross
   		   buysig=true;
    	}

      if (stom1<stos1 && stom2>=stos2 && stom2>UpperLevel) { //short cross
   		   sellsig=true;
      }
      closebuy=sellsig;
      closesell=buysig;
      
}

void CheckForOpen() {
   int    res;
   double entry,stop,profit;

   if (last != Time[0] && CalculateLong()+CalculateShort()!=0) 
      CheckForClose();

//---- buy conditions
   if (buysig && last != Time[0])  {
  		   res=0;
  		   tries=0;
   		while (res<=0 && tries<OrderNumberTries) {
   		    while(!IsTradeAllowed()) Sleep(5000);
   		    RefreshRates();
   		    last = Time[0];
			    entry=Ask;
			    stop=entry-StopLoss*Point;
			    profit=entry+TakeProfit*Point;
			    res=OrderSend(Symbol(),OP_BUY,LotsRisk(StopLoss),entry,slippage,stop,profit,"stoc",myMagic,0,Blue);
			    if (res<0) Print("Error opening BUY order : ",ErrorDescription(GetLastError()));
			    tries++;
   		}
   }
//---- sell conditions
   if (sellsig && last != Time[0])  {
  		   res=0;
  		   tries=0;
   		while (res<=0 && tries<OrderNumberTries) {
   		    while(!IsTradeAllowed()) Sleep(5000);
   		    RefreshRates();
   		    last = Time[0];
			    entry=Bid;
			    stop=entry+StopLoss*Point;
			    profit=entry-TakeProfit*Point;
			    res=OrderSend(Symbol(),OP_SELL,LotsRisk(StopLoss),entry,slippage,stop,profit,"stoc",myMagic,0,Red);
			    if (res<0) Print("Error opening SELL order : ",ErrorDescription(GetLastError()));
			    tries++;
   		}
   }
}
  
  
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()  {
	int total,pbar;
//----
	total=OrdersTotal();
   for(int i=total-1;i>=0;i--) {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)  continue;
      if(OrderMagicNumber()!=myMagic || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY) {
         if (closebuy) {
            bres=false;
            tries=0;
            while (!bres && tries<OrderNumberTries) {
   		       while(!IsTradeAllowed()) Sleep(5000);
               RefreshRates();
               bres=OrderClose(OrderTicket(),OrderLots(),Bid,slippage,White);
               Sleep(3000);
			      if (!bres) Print("Error closing order : ",ErrorDescription(GetLastError()));
			      tries++;
			   }
		   }
      }
      if(OrderType()==OP_SELL) {
         if (closesell) {
            bres=false;
            tries=0;
            while (!bres && tries<OrderNumberTries) {
   		       while(!IsTradeAllowed()) Sleep(5000);
               RefreshRates();
               bres=OrderClose(OrderTicket(),OrderLots(),Ask,slippage,White);
               Sleep(3000);
			      if (!bres) Print("Error closing order : ",ErrorDescription(GetLastError()));
			      tries++;
			   }
			}
      }
   }
}


void TrailStop() {
   bool bres;
   double StopLoss;
   if ( TrailingStop > 2 ) {
      for (int i = 0; i < OrdersTotal(); i++) {
         if ( OrderSelect (i, SELECT_BY_POS) == false )  continue;
         if ( OrderSymbol() != Symbol() || OrderMagicNumber() != myMagic )  continue;
         if ( OrderType() == OP_BUY ) {
            if ( Bid < OrderOpenPrice()+TrailingStop*Point )  return;
            StopLoss = Bid-TrailingStop*Point;
            if ( StopLoss > OrderStopLoss() ) {
   		       while(!IsTradeAllowed()) Sleep(5000);
                  bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, White);
                  Sleep(3000);
					   if (!bres) Print("Error Modifying BUY order : ",ErrorDescription(GetLastError()));
            }
         }
   
         if ( OrderType() == OP_SELL ) {
            if ( Ask > OrderOpenPrice()-TrailingStop*Point )  return;
            StopLoss = Ask+TrailingStop*Point;
            if ( StopLoss < OrderStopLoss() ) {
   		       while(!IsTradeAllowed()) Sleep(5000);
                  bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, Gold);
                  Sleep(3000);
					   if (!bres) Print("Error Modifying SELL order : ",ErrorDescription(GetLastError()));
            }
         }
      }
   }
   return;
}


void start()  {

   //---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;

   //---- check for signals
   CheckForSignals();

   CheckForOpen();
   
   TrailStop();

}



